//Add Loadout Loader
if !variable_global_exists('gg2iHttpHandler')
{
	globalvar gg2iHttpHandler;
	gg2iHttpHandler = object_add();
	object_set_persistent(gg2iHttpHandler, true);
	object_event_add(gg2iHttpHandler, ev_create, 0, "
		var message;
		working = false;
		request_queue = ds_queue_create();			//Save informations in integer
		player_queue = ds_queue_create();			//Which player to do action
		get_loadout_http = gg2i.basehttp + '/getloadout';
		get_item_http = gg2i.basehttp + '/gotpresent';
		get_strange_http = gg2i.basehttp + '/updatestrange';
		http_buffer = buffer_create();
		var owner_item_got;
		owner_item_got = false;
		with (global.myself)
		{
			if (variable_local_exists('gg2i_item_got'))
			{
				if (gg2i_item_got)
					owner_item_got = true;
			}
		}
		if (!owner_item_got)
			event_user(0); //get loadout
	");
	
	object_event_add(gg2iHttpHandler, ev_destroy, 0, "
		ds_queue_destroy(request_queue);
		ds_queue_destroy(player_queue);
		buffer_destroy(http_buffer);
	");
	
	object_event_add(gg2iHttpHandler, ev_step, ev_step_begin, "
		if (working)
		{
			if(http_step(connection))
			{
				working = false;
				// Errored
				if (http_status_code(connection) != 200)
				{
					switch (request)
					{
						case 1:
							message = 'Item getting failed!: ' + string(http_status_code(connection)) + ' with ' + player.name;
							break;
						case 2:
							message = 'Loading loadout failed!: ' + string(http_status_code(connection)) + ' with ' + player.name;
							break;
						case 3:
							message = 'Strange update failed!: ' + string(http_status_code(connection)) + ' with ' + player.name;
							break;
						default:
							exit;
					}
					ServerMessageString(message, global.sendBuffer);
					with NoticeO instance_destroy();
					notice = instance_create(0, 0, NoticeO);
					notice.notice = NOTICE_CUSTOM;
					notice.message = message;
				}
				else
				{
					switch (request)
					{
						case 1:
							body_str = read_string(http_response_body(connection), http_response_body_size(connection));
							message = player.name + ' has got ' + body_str;
							ServerMessageString(message, global.sendBuffer);
							with NoticeO instance_destroy();
							notice = instance_create(0, 0, NoticeO);
							notice.notice = NOTICE_CUSTOM;
							notice.message = message;
							break;
					}
					player = -1;
					request = -1;
				}
				buffer_clear(http_buffer);
				http_destroy(connection);
			}
		}
		else if (!ds_queue_empty(request_queue) && !working)
		{
			working = true;
			request = ds_queue_dequeue(request_queue);
			if (ds_queue_empty(player_queue))
			{
				working = false;
				request = -1;
				exit;
			}
			player = ds_queue_dequeue(player_queue);
			switch(request)
			{
				//Someone got item
				case 1:
					write_string(http_buffer, 'unique_key=' + player.key);
					connection = http_new_post(get_item_http, http_buffer, 'application/x-www-form-urlencoded');
					break;
				//Player change loadout
				case 2:
					break;
				//Player update strange count
				case 3:
					connection = http_new_post(get_strange_http, http_buffer, 'application/x-www-form-urlencoded');
					break;
				default:
					working = false;
					request = -1;
					player = -1;
					break;
			}
		}
	");
}

//Get loadout by beginning of entering server & Refresh
if (variable_global_exists('gg2iHttpHandler')) {
	object_event_add(gg2iHttpHandler, ev_other, ev_user0, "
		if (!variable_global_exists('gg2i_using_clientside'))
		{
			//Players should have unique_key variable verified!
			if(variable_global_exists('unique_key'))
			{
				global.myself.key = global.unique_key;
				write_string(http_buffer, 'user_key=' + global.unique_key);
				get_loadout_handler = http_new_post(get_loadout_http, http_buffer, 'application/x-www-form-urlencoded');
				while(!http_step(get_loadout_handler)) 
				{
					sleep(floor(1000/30));
					io_handle();
				} 
				// Errored
				if (http_status_code(get_loadout_handler) != 200)
				{
					show_message('Downloading loadout failed!#' + string(http_status_code(get_loadout_handler)) + ' ' + http_reason_phrase(get_loadout_handler));
					game_end();
				}
				loadout_str = read_string(http_response_body(get_loadout_handler), http_response_body_size(get_loadout_handler));
				if (loadout_str == '') //This happens when loadout load failed(like unique_key doesn't exist)
				{
					show_message('Loading loadout failed!');
					game_end();
				}
				http_destroy(get_loadout_handler);
				buffer_clear(http_buffer);
				item_lists = split(loadout_str, ';'); //list with string elements
				
				global.myself.gg2i_head_list = split(ds_list_find_value(item_lists, 0), ',');
				global.myself.gg2i_torso_list = split(ds_list_find_value(item_lists, 1), ',');
				global.myself.gg2i_leg_list = split(ds_list_find_value(item_lists, 2), ',');
				global.myself.gg2i_weapon_list = split(ds_list_find_value(item_lists, 3), ',');
				global.myself.gg2i_misc_list = split(ds_list_find_value(item_lists, 4), ',');
				global.myself.gg2i_taunt_list = split(ds_list_find_value(item_lists, 5), ',');
				global.myself.gg2i_pet_list = split(ds_list_find_value(item_lists, 6), ',');
				global.myself.gg2i_death_list = split(ds_list_find_value(item_lists, 7), ',');
				global.myself.gg2i_humiliation_list = split(ds_list_find_value(item_lists, 8), ',');
				global.myself.gg2i_title = ds_list_find_value(item_lists, 9);
				global.myself.gg2i_item_got = true;
				global.myself.is_gg2s_user = true;
				ds_list_destroy(item_lists);
			}
			else
			{
				loadout_str = ',,,,,,,,,;' + ',,,,,,,,,;' + ',,,,,,,,,;' + ',,,,,,,,,;' + ',,,,,,,,,;' + ',,,,,,,,,;' + ',,,,,,,,,;' + ',,,,,,,,,;' + ',,,,,,,,,;' + '';
				for (i = 0; i < 10; i += 1)
				{
					ds_list_add(global.myself.gg2i_head_list, '');
					ds_list_add(global.myself.gg2i_torso_list, '');
					ds_list_add(global.myself.gg2i_leg_list, '');
					ds_list_add(global.myself.gg2i_weapon_list, '');
					ds_list_add(global.myself.gg2i_misc_list, '');
					ds_list_add(global.myself.gg2i_taunt_list, '');
					ds_list_add(global.myself.gg2i_pet_list, '');
					ds_list_add(global.myself.gg2i_death_list, '');
					ds_list_add(global.myself.gg2i_humiliation_list, '');
				}
				global.myself.gg2i_title = '';
				global.myself.gg2i_item_got = true;
				global.myself.is_gg2s_user = false;
			}
				
			for (i = 0; i < 10; i += 1)
			{
				global.myself.gg2i_unusual[i] = -1;
				global.myself.gg2i_strange_type[i] = -1;
				global.myself.gg2i_strange_count[i] = 0;
			}
			
			//Unusual
			for (i = 0; i < 10; i += 1)
			{
				if (string_count('+', ds_list_find_value(global.myself.gg2i_head_list, i)) > 0)
				{
					temp_list = split(ds_list_find_value(global.myself.gg2i_head_list, i), '+');
					ds_list_replace(global.myself.gg2i_head_list, i, ds_list_find_value(temp_list, 0));
					global.myself.gg2i_unusual[i] = real(ds_list_find_value(temp_list, 1));
					ds_list_destroy(temp_list);
				}
			}
			
			//Strange
			for (i = 0; i < 10; i += 1)
			{
				if (string_count('+', ds_list_find_value(global.myself.gg2i_weapon_list, i)) > 0)
				{
					temp_list = split(ds_list_find_value(global.myself.gg2i_weapon_list, i), '+');
					temp_list2 = split(ds_list_find_value(temp_list, 1), '-');
					ds_list_replace(global.myself.gg2i_weapon_list, i, ds_list_find_value(temp_list, 0));
					global.myself.gg2i_strange_type[i] = real(ds_list_find_value(temp_list2, 0));
					global.myself.gg2i_strange_count[i] = real(ds_list_find_value(temp_list2, 1));
					ds_list_destroy(temp_list);
					ds_list_destroy(temp_list2);
				}
			}
			
			//If character object exists, re-spawn it
			if (global.myself.object != -1)
			{
				global.myself.gg2i_item_set = false;
				ClientPlayerChangeclass(global.myself.class, global.serverSocket);
				socket_send(global.serverSocket);
			}
		
		}
		
		//Send host own loadout information
		if (!global.isHost)
		{
			buffer_clear(gg2i.messageBuffer);
			write_ubyte(gg2i.messageBuffer, 0);
			if (variable_global_exists('unique_key'))
			{
				write_ubyte(gg2i.messageBuffer, string_length(global.unique_key));
				write_string(gg2i.messageBuffer, global.unique_key);
			}
			else
			{
				write_ubyte(gg2i.messageBuffer, 0);
				write_string(gg2i.messageBuffer, '');
			}
			write_string(gg2i.messageBuffer, loadout_str);
			PluginPacketSend(gg2i.packetID, gg2i.messageBuffer);
			buffer_clear(gg2i.messageBuffer);
		}
		//Send other players own loadout information if host
		else
		{
			buffer_clear(gg2i.messageBuffer);
			write_ubyte(gg2i.messageBuffer, 0);
			write_ubyte(gg2i.messageBuffer, ds_list_find_index(global.players, global.myself));
			write_ubyte(gg2i.messageBuffer, global.myself.is_gg2s_user);
			write_string(gg2i.messageBuffer, loadout_str);
			PluginPacketSend(gg2i.packetID, gg2i.messageBuffer);
			buffer_clear(gg2i.messageBuffer);
		}
	");
}

if (!variable_global_exists("gg2i_using_clientside")) {
	//Make gg2iHttpHandler object for each player
	object_event_add(PlayerControl, ev_step, ev_step_begin, "
		if(!instance_exists(gg2iHttpHandler))
			instance_create(0, 0, gg2iHttpHandler);
	");
}

//Http Stepper Class(Updates stat to server)
if !variable_global_exists('httpStepper')
{
	global.httpStepper = object_add();
	object_set_persistent(global.httpStepper, true);
	object_event_add(global.httpStepper, ev_step, ev_step_begin, "
		if (working)
		{
			if(http_step(connection))
			{
				working = false;
				// Errored
				if (http_status_code(connection) != 200)
				{
					show_message('GG2Stats Update Failed!: ' + string(http_status_code(connection)));
				}
				http_destroy(connection);
			}
		}
	");
	
	object_event_add(global.httpStepper, ev_other, ev_user0, "
		connection = http_new_post(http, http_buffer, 'application/x-www-form-urlencoded');
		working = true;
	");
}