/*
 *	GG2I: Gang Garrison 2 Itemserver
 *	Original Creator: WoodNeck
 *	Now in Charge: BuTt
 *
 *	Please contact me via Discord:
 *	Pan-tiently Dying#3798 or the GG2 discord
 *	
 *	
 */
 
//Declaring global variables
globalvar gg2i;
gg2i = id; //Current Plugin Environment
gg2i.tempDirectory = argument0;
gg2i.spriteDirectory = working_directory + "\GG2IResource"
gg2i.packetID = argument1;
gg2i.messageBuffer = buffer_create();
gg2i.basehttp = 'http://gg2statsapp.appspot.com'
gg2i.playerCount = 0;
gg2i.present_possibility = 0;
gg2i.item_version = 0;
gg2i.smallQuote = "'";
gg2i.bigQuote = '"';

//Download information from web
item_info_download_http = gg2i.basehttp + '/download/gg2i.zip';
item_info_handler = http_new_get(item_info_download_http);
while(!http_step(item_info_handler)) 
{
	sleep(floor(1000/30));
	io_handle();
}

// Errored
if (http_status_code(item_info_handler) != 200)
{
	show_message('Download failed!');
	game_end();
}

item_info_temp_file = working_directory + "\GG2IResource\_gg2i_item_info.zip";

write_buffer_to_file(http_response_body(item_info_handler), item_info_temp_file);
http_destroy(item_info_handler);

if(!file_exists(item_info_temp_file))
{
    show_message("Missing Item info file in temp directory, download failed.");
    game_end();
}

extractzip(item_info_temp_file, gg2i.spriteDirectory);

//Read Downloaded Setting File
ini_open('gg2.ini');
gg2i.item_version = real(ini_read_string('GG2Stats', 'Item Version', '0'));
ini_close();

info_str = '';
info_file = file_text_open_read(gg2i.spriteDirectory  + "/setting.txt");
while(!file_text_eoln(info_file))
{
	info_str += file_text_read_string(info_file);
	file_text_readln(info_file);
}
file_text_close(info_file);

var setting_map;
setting_map = ggon_decode(info_str);
gg2i.present_possibility = real(ds_map_find_value(setting_map, 'present_possibility'));
version_got = real(ds_map_find_value(setting_map, 'item_version'));
ds_map_destroy(setting_map);

//Check whether item version is updated
if (version_got > gg2i.item_version or !directory_exists(gg2i.spriteDirectory))
{
	//Download sprite from web
	item_download_http = gg2i.basehttp + '/download/items.zip';
	item_handler = http_new_get(item_download_http);
	while(!http_step(item_handler)) 
	{
		sleep(floor(1000/30));
		io_handle();
	}

	// Errored
	if (http_status_code(item_handler) != 200)
	{
		show_message('Download failed!');
		game_end();
	}

	item_temp_file = temp_directory + "\_gg2i_item_sprite.zip";

	write_buffer_to_file(http_response_body(item_handler), item_temp_file);
	http_destroy(item_handler);

	if(!file_exists(item_temp_file))
	{
		show_message("Missing Item sprite file in temp directory, download failed.");
		game_end();
	}

	extractzip(item_temp_file, gg2i.spriteDirectory);
	
	ini_open('gg2.ini');
	ini_write_string('GG2Stats', 'Item Version', string(version_got));
	ini_close();
}

//load sprite
execute_file(gg2i.tempDirectory+'/sprite.gml');

//add network class
execute_file(gg2i.tempDirectory+'/network.gml');

//add http handling class
execute_file(gg2i.tempDirectory+'/http.gml');

//set character's loadout
execute_file(gg2i.tempDirectory+'/setter.gml');

//code for hat, torso, leg
execute_file(gg2i.tempDirectory+'/cloth.gml');

//code for misc items(includes pet, humil, d.anim)
execute_file(gg2i.tempDirectory+'/misc.gml');

//code for weapon
execute_file(gg2i.tempDirectory+'/weapon.gml');

//code for present
execute_file(gg2i.tempDirectory+'/present.gml');

/////////////////////////////////////////////////////////////////////////////////////
/*								Add loadout refresh menu								*/
/////////////////////////////////////////////////////////////////////////////////////
object_event_add(InGameMenuController,ev_create,0,"
	if (variable_global_exists('gg2iHttpHandler'))
		menu_addlink('Refresh Loadout', '
			with(gg2iHttpHandler)
				event_user(0);
			instance_destroy();
		');
");

if (!variable_global_exists("gg2i_using_clientside")) {
	object_event_add(Character, ev_create, 0, "
		timer = 0;
	");

	object_event_add(Character, ev_step, ev_step_end, "
		timer += 1 * global.delta_factor;
	");
}