//--------------------------------PRESENT RELATED CODE--------------------------------//
if !(variable_global_exists("gg2i_item_present")) {
	globalvar gg2i_item_present;
	gg2i_item_present = object_add();
	object_event_add(gg2i_item_present, ev_create, 0, "
		image_speed = 0;
		image_xscale = 1.5;
		image_yscale = 1.5;
		sprite_index = gg2i_item_presentS;
		alarm[0] = 1800/global.delta_factor; //1min
		team = TEAM_SPECTATOR;
	");

	object_event_add(gg2i_item_present, ev_alarm, 0,"
		instance_destroy();
	");

	object_event_add(gg2i_item_present, ev_draw, 0,"
		if (team == TEAM_RED)
		{
			image_index = 0;
		}
		else
		{
			image_index = 2;
		}
		if (alarm[0] < 930/global.delta_factor)
		{
			if (alarm[0] < 330/global.delta_factor)
				draw_set_color(c_red);
			else
				draw_set_color(c_white);
			draw_set_halign(fa_left);
			draw_text(x, y - 7, string(alarm[0] div (30/global.delta_factor)));
		}
		draw_sprite_ext(sprite_index, image_index, x, y, image_xscale, image_yscale, 0, c_white, image_alpha);
	");

	object_event_add(gg2i_item_present, ev_collision, Character,"
		if (other.team != team)
		{
			if (other.player.is_gg2s_user)
			{
				if (global.isHost)
				{
					ds_queue_enqueue(gg2iHttpHandler.request_queue, 1);
					ds_queue_enqueue(gg2iHttpHandler.player_queue, other.player);
				}
				instance_destroy();
			}
		}
	");
}

object_event_add(Character, ev_step, ev_step_end, "
	if (global.isHost && hp <= 0)
	{
		if (random(1) < min(timer/900, gg2i.present_possibility)) //it takes at least 30 sec to max possibility
		{
			gg2i_player_count_map = ds_map_create();
			for (i = 0; i < ds_list_size(global.players); i += 1)
			{
				ds_map_add(gg2i_player_count_map, socket_remote_ip(ds_list_find_value(global.players, i).socket), true);
			}
			player_count = ds_map_size(gg2i_player_count_map);
			ds_map_destroy(gg2i_player_count_map);
			if (player_count >= 4) //need at least 4 players
			{
				if (irandom(9) < min(player_count, 10))
				{
					present = instance_create(x, y, gg2i_item_present);
					present.image_index = 2*player.team;
					present.team = player.team;
					gg2iMessageHandler.present = present;
					with (gg2iMessageHandler)
						event_user(0);
				}
			}
		}
	}
");